local idTweaksOptions, idTweaksUtils, map, get_db_option, set_db_option, Option
do
  local _obj_0 = _G
  idTweaksOptions, idTweaksUtils = _obj_0.idTweaksOptions, _obj_0.idTweaksUtils
end
map = idTweaksUtils.table.map
do
  local _obj_0 = idTweaksUtils.db
  get_db_option, set_db_option = _obj_0.get_db_option, _obj_0.set_db_option
end
do
  local _class_0
  local _base_0 = {
    get_display_key = function(self)
      if self.parent then
        return tostring(self.parent:get_display_key()) .. " " .. tostring(self.key)
      else
        return self.key
      end
    end,
    get_display_value = function(self, value)
      if value == true then
        return "On"
      elseif value == false then
        return "Off"
      else
        return value
      end
    end,
    get_full_key = function(self)
      if self.parent and self.parent.key ~= self.module.name and self.parent.key ~= "idTweaks" then
        return tostring(self.parent:get_full_key()) .. "." .. tostring(self.key)
      else
        return self.key
      end
    end,
    get = function(self)
      return map.get(self:get_full_key(), self.module.db)
    end,
    set = function(self, value)
      map.set(value, self:get_full_key(), self.module.db)
      return self.module:check()
    end,
    add_value = function(self, key, value)
      self.values[key] = value
    end,
    remove_value = function(self, key)
      self.values[key] = nil
    end,
    get_option = function(self, key)
      return self.options[key]
    end,
    add_option = function(self, option)
      self.options[option.key] = option
      self.options[option.key].order = self.num_options
      self.num_options = self.num_options + 1
      option.parent = self
    end,
    remove_option = function(self, option)
      option.parent = nil
      self.options[option.key] = nil
    end,
    get_aceconfig_defaults = function(self)
      if self.num_options == 0 then
        return self.default
      else
        return map.map((function(v)
          return v:get_aceconfig_defaults()
        end), self.options)
      end
    end,
    get_aceconfig_options = function(self)
      local output = {
        order = self.order,
        type = self.type,
        name = self.name,
        desc = self.description,
        disabled = self:create_disabled(),
        hidden = self:create_hidden(),
        get = self:create_get(),
        set = self:create_set()
      }
      if self.num_options > 0 then
        output.args = map.map((function(v)
          return v:get_aceconfig_options()
        end), self.options)
      end
      return output
    end,
    create_disabled = function(self)
      return function()
        return false
      end
    end,
    create_hidden = function(self)
      return function()
        return false
      end
    end,
    create_get = function(self)
      return function()
        return self:get()
      end
    end,
    create_set = function(self)
      return function(_, value)
        return self:set(value)
      end
    end
  }
  _base_0.__index = _base_0
  _class_0 = setmetatable({
    __init = function(self, module_instance, key, name, description, values, options, default)
      if values == nil then
        values = { }
      end
      if options == nil then
        options = { }
      end
      self.order = 0
      self.parent = nil
      self.type = "group"
      self.module = module_instance
      self.key = key
      self.name = name
      self.description = description
      map.each((function(v, k)
        self["create_" .. tostring(k)] = function(self)
          return v
        end
      end), values)
      self.num_options = 0
      self.options = { }
      map.each((function(v)
        return self:add_option(v)
      end), options)
      self.default = default
    end,
    __base = _base_0,
    __name = "Option"
  }, {
    __index = _base_0,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  Option = _class_0
end
idTweaksOptions.Option = Option
