local *

{ :idTweaksUtils, :idTweaksOptions } = _G
{ :Option } = idTweaksOptions
{ :map } = idTweaksUtils.table

class RangeOption extends Option
  new: (module_instance, key, name, description, values = {}, options = {}, default = 0) =>
    -- print "RangeOption#new:#{key}"

    super module_instance, key, name, description, values, options, default

    @type = "range"

  get_aceconfig_options: =>
    -- print "RangeOption#get_aceconfig_options:#{@key}"

    output =
      order: @order
      type: @type
      name: @name
      desc: @description
      disabled: @create_disabled!
      hidden: @create_hidden!
      get: @create_get!
      set: @create_set!
      min: @create_min!
      max: @create_max!
      step: @create_step!

    if @num_options > 0
      output.args = map.map ((v) -> v\get_aceconfig_options!), @options

    output

  create_min: =>
    ->
      -- print "RangeOption#create_min:#{@key}"
      0

  create_max: =>
    ->
      -- print "RangeOption#create_max:#{@key}"
      10

  create_step: =>
    ->
      -- print "RangeOption#create_step:#{@key}"
      1

idTweaksOptions.RangeOption = RangeOption
